=== debian/changelog ===
fenics-basix (0.3.0-11build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 22:37:22 +0000

fenics-basix (0.3.0-11) unstable; urgency=medium

  * debian patch build_any_xtensor.patch allows building against more
    recent xtensor (and xsimd) versions. Removes xsimd detection
    (which is performed by the xtensor config files)
    cf. https://github.com/FEniCS/basix/issues/348
    - make xtl, xtensor, xtensor-blas required (don't fetch source)

 -- Drew Parsons <dparsons@debian.org>  Thu, 02 Dec 2021 17:19:37 +0100

fenics-basix (0.3.0-10) unstable; urgency=medium

  * skip numba tests on mipsel
  * debian patch reproducible_docs.diff makes the doc build
    reproducible. Thanks Chris Lamb. Closes: #996999.

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Oct 2021 18:06:12 +0200

fenics-basix (0.3.0-9) unstable; urgency=medium

  * drop arm64 from xsimd-supported arch list. xsimd fails tests on
    arm64 (see also xtensor xsimd support)

 -- Drew Parsons <dparsons@debian.org>  Thu, 21 Oct 2021 00:02:29 +0200

fenics-basix (0.3.0-8) experimental; urgency=medium

  * fix skip_flaky_arch_numba_tests.patch to import pytest first.
    Rename skip_armel_numba_tests.py as skip_flaky_arch_numba_tests.patch

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 19:15:37 +0200

fenics-basix (0.3.0-7) experimental; urgency=medium

  * rename debian patch skip_armel_numba_tests.py to
    skip_flaky_arch_numba_tests.py, and add s390x, ppc64 alongside
    armel as arches for which numba is available but not reliable.
    Skip these arches before testing if numba is available
    (test_numba_conditional.patch) since even just loading numba can
    trigger a segfault on these arches.

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 17:27:19 +0200

fenics-basix (0.3.0-6) experimental; urgency=medium

  * debian patch test_numba_conditional.patch skips test_numba.py if
    numba cannot be imported (it's not available on all arches).
  * explicitly switch xsimd support off except for arches where it
    is known to work (amd64, arm64; kfreebsd is untested).
    libxsimd-dev is available on some arches such as i386, m68k,
    but no xsimd instructions are actually available which causes
    problems with the basix build (warnings are treated as errors)

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 13:49:30 +0200

fenics-basix (0.3.0-5) experimental; urgency=medium

  * remove m68k, sh4 from xsimd list. They don't actually have any
    xsimd instructions (same problem as i386).
  * build python docs in arch-independent build
  * python3-basix Recommends: python3-numba

 -- Drew Parsons <dparsons@debian.org>  Sun, 10 Oct 2021 09:23:47 +0200

fenics-basix (0.3.0-4) experimental; urgency=medium

  * use numba only where available. Build-Depends: python3-numba
    [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64]
  * add :any to Build-Depends: python3-all-dev:any

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Oct 2021 23:46:02 +0200

fenics-basix (0.3.0-3) experimental; urgency=medium

  * debian patch skip_armel_numba_tests.py skips numba tests on armel
    (armv7l). Numba is flakey on armel, see Bug#994294.

 -- Drew Parsons <dparsons@debian.org>  Fri, 01 Oct 2021 16:33:35 +0200

fenics-basix (0.3.0-2) experimental; urgency=medium

  * drop x86 arches (i386 hurd-i386 x32) from xsimd support,
    tracking support in xtensor.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Sep 2021 00:11:30 +0200

fenics-basix (0.3.0-1) experimental; urgency=medium

  * New upstream release.
    - dirs updated from basix/cpp to cpp/basix
    - source docs moved to doc subdir
  * Standards-Version: 4.6.0
  * Build with xsimd support (-DXTENSOR_USE_XSIMD=ON) where available
    Build-Depends: libxsimd-dev (>= 7.4.10~)
    [amd64 arm64 i386 hurd-i386 kfreebsd-any m68k sh4 x32]
  * debian patch fix_doc_build.patch fixes doc configuration
    (header.html changed to header.html.template)
    Needs doxygen -u to update obsolete tags.

 -- Drew Parsons <dparsons@debian.org>  Thu, 09 Sep 2021 03:19:20 +0300

fenics-basix (0.1.0-1) experimental; urgency=medium

  * update source package name to fenics-basix
    - update Vcs salsa paths
  * First official upstream release.
    - Build-Depends: xtl-dev (>= 0.7.0~)
    - Build-Depends: python3-numba (for tests)
    - deprecates debian patch include_path.patch
  * versioned Build-Depends: libxtensor-blas-dev (>= 0.19~)
  * update xtensor Build-Depends to libxtensor-dev
  * debian/rules clean removes basix/cpp/basix/version.h and
    python/build if present
  * run python tests using install dir not build dir

 -- Drew Parsons <dparsons@debian.org>  Thu, 27 May 2021 15:38:37 +0200

basix (0.0.1~git20210409.b980196-2) experimental; urgency=medium

  * provide python docs in basix-docs (built using sphinx)
    - doc-base points at python docs, index.html links to C++ docs
  * skip build-time tests if nocheck is set in DEB_BUILD_OPTIONS
  * override_dh_auto_clean removes python build and test dirs and
    generated cpp/docs

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Apr 2021 21:31:37 +0200

basix (0.0.1~git20210409.b980196-1) experimental; urgency=medium

  * New upstream snapshot.
    - uses xtensor and drops skbuild
  * Build-Depends: xtensor-dev (>= 0.23.4~), xtensor-blas-dev
    - xtensor-dev 0.23 implies xtl-dev (>= 0.7.0~), which is also
      required by basix (in CMakeLists.txt), but not used directly.
  * versioned Build-Depends: cmake (>= 3.16), xtensor-dev (>= 0.23~)
  * drop debian patch test_permutation_nedelec_32bit_xfail.patch
    (obsolete, test_permutations.py no longer exists)
  * add debian patches
    - skip_runpath.patch keeps RPATH from being injected into libraries
      built by cmake (in particular the python extension library)
    - find_generic_blas.patch instructs cmake to find generic libblas.so

