=== debian/tests/control ===
Test-Command: pytest-3
Depends: python3-basix,
 python3-pytest,
 python3-fiat,
 python3-numba [amd64 arm64 armel armhf i386 mips64el ppc64el s390x ppc64],
 python3-numpy,
 python3-sympy
