## fenics-basix 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(BasixFull VERSION "0.4.2" LANGUAGES CXX)
add_subdirectory(cpp)
add_subdirectory(python)
