=== debian/changelog ===
fenics-basix (0.4.2-6) unstable; urgency=medium

  * use epoch with ffcx version.
    python3-basix Breaks: python3-ffcx (<< 1:0.4~)

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Jul 2022 22:17:23 +0200

fenics-basix (0.4.2-5) unstable; urgency=medium

  * python3-basix Breaks: python3-ffcx (<< 0.4~)
    to facilitate migration to testing

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Jul 2022 11:03:17 +0200

fenics-basix (0.4.2-4) unstable; urgency=medium

  * set libbasix-dev Depends: libxtensor-dev, libxsimd-dev with
    versions that basix was built against.

 -- Drew Parsons <dparsons@debian.org>  Wed, 29 Jun 2022 18:32:41 +0200

fenics-basix (0.4.2-3) unstable; urgency=medium

  * add arm64 to list of xsimd-supported architectures.
    Should run fine with xsimd 0.8.1-3 and xtensor 0.24.
    armhf and i386 still fail xsimd tests so don't add them yet.
    Closes: #1013626.

 -- Drew Parsons <dparsons@debian.org>  Sat, 25 Jun 2022 13:04:28 +0200

fenics-basix (0.4.2-2) unstable; urgency=medium

  * push FEniCS-x 0.4 to unstable

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Jun 2022 12:45:08 +0200

fenics-basix (0.4.2-1exp2) experimental; urgency=medium

  * build python module also in arch-indep builds to enable doc build
    Closes: #1012022.

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Jun 2022 11:13:03 +0200

fenics-basix (0.4.2-1exp1) experimental; urgency=medium

  * New upstream release.
    - versioned Build-Depends: libxtensor-dev (>= 0.23.10~)
  * Build-Depends: python3-ufl not python3-fiat (used in tests)

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 May 2022 18:49:49 +0200

fenics-basix (0.4.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - drop Build-Depends: libxtensor-blas-dev
    - add Build-Depends: libblas-dev, liblapack-dev (or alternatives)
  * bump library soname to libbasix0.4
  * drop redundant debian patch build_any_xtensor.patch
  * debian/rules: use execute_after[before] instead of override_
  * debian patch python_cmake_options.patch enables extra cmake
    options to be provided to a standalone build of the python module
    i.e. to provide XTENSOR configuration to be consistent with the
    C++ library configuration.
  * update debian patch fix_doc_build.patch to build docs using
    local mathjax
  * point debian/pybuild.testfiles at test dir to enable pybuild tests
    for all supported python versions
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 May 2022 13:10:24 +0200

fenics-basix (0.3.0-12) unstable; urgency=medium

  * switch off all numba tests until numba is again available
    (currently removed due to python3.10 incompatibility)
    Closes: #1008522.

 -- Drew Parsons <dparsons@debian.org>  Fri, 01 Apr 2022 16:49:42 +0200
