=== debian/control ===
--- 
+++ 
@@ -7,8 +7,7 @@
  dh-python,
  python3-setuptools,
  python3-all-dev:any,
- python3-fiat,
- python3-numba [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64],
+ python3-ufl,
  python3-numpy,
  python3-pybind11 (>= 2.6.0~),
  python3-pytest,
@@ -21,12 +20,13 @@
  libeigen3-dev,
  libjs-mathjax,
  ninja-build,
- libxtensor-dev (>= 0.23.4~),
- libxtensor-blas-dev (>= 0.19~),
- libxsimd-dev (>= 7.4.10~) [amd64 kfreebsd-any],
+ libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
+ liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
+ libxtensor-dev (>= 0.23.10~),
+ libxsimd-dev (>= 7.4.10~) [amd64 arm64 kfreebsd-any],
  xtl-dev (>= 0.7.0~)
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/FEniCS/basix
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
 Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
@@ -36,8 +36,10 @@
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0 (= ${binary:Version}),
+Depends: libbasix0.4 (= ${binary:Version}),
  libeigen3-dev,
+ libxtensor-dev (>= ${xtensor:Upstream-Version}~),
+ libxsimd-dev (>= ${xsimd:Upstream-Version}~) [amd64 arm64 kfreebsd-any],
  ${misc:Depends}, ${shlibs:Depends}
 Suggests: python3-basix, basix-doc
 Description: Finite Element Basis Function Definition Runtime Library (development headers)
@@ -60,7 +62,7 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0
+Package: libbasix0.4
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -90,6 +92,7 @@
 Depends: libbasix-dev  (= ${binary:Version}),
  ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-numba
+Breaks: python3-ffcx (<< 1:0.4~)
 Suggests: basix-doc
 Description: Finite Element Basis Function Definition Runtime Library (Python 3)
  Computes FE basis functions and derivatives for the following
